Index: trunk/drmaa_utils/Doxyfile.in
===================================================================
--- trunk/drmaa_utils/Doxyfile.in	(revision 1)
+++ trunk/drmaa_utils/Doxyfile.in	(revision 1)
@@ -0,0 +1,30 @@
+PROJECT_NAME           = "@PACKAGE_NAME@"
+PROJECT_NUMBER         = @PACKAGE_VERSION@
+INPUT                  = @top_srcdir@/drmaa_utils
+EXCLUDE                = \
+ @top_srcdir@/drmaa_utils/datetime_tab.c \
+ @top_srcdir@/drmaa_utils/datetime_tab.h \
+ @top_srcdir@/drmaa_utils/conf_tab.c \
+ @top_srcdir@/drmaa_utils/conf_tab.h \
+ @top_srcdir@/drmaa_utils/drmaa_attrib.c
+OUTPUT_DIRECTORY       = apidoc
+
+ENABLE_PREPROCESSING   = YES
+PREDEFINED             = __GNUC__
+
+JAVADOC_AUTOBRIEF      = YES
+EXTRACT_ALL            = NO
+HIDE_UNDOC_MEMBERS     = NO
+SORT_BRIEF_DOCS        = NO
+SORT_MEMBER_DOCS       = NO
+DETAILS_AT_TOP         = YES
+OPTIMIZE_OUTPUT_FOR_C  = YES
+TAB_SIZE               = 2
+GENERATE_TODOLIST      = YES
+SHOW_DIRECTORIES       = NO
+
+HAVE_DOT               = @HAVE_DOT@
+CALL_GRAPH             = YES
+
+GENERATE_HTML          = YES
+GENERATE_LATEX         = NO
Index: trunk/drmaa_utils/Makefile.am
===================================================================
--- trunk/drmaa_utils/Makefile.am	(revision 1)
+++ trunk/drmaa_utils/Makefile.am	(revision 1)
@@ -0,0 +1,28 @@
+# $Id: Makefile.am 2248 2009-03-20 14:20:56Z lukasz $
+#
+# FedStage DRMAA utilities library
+# Copyright (C) 2006-2008  FedStage Systems
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+ACLOCAL_AMFLAGS = -I m4
+EXTRA_DIST = \
+ autoclean.sh \
+ autogen.sh \
+ m4/bison_ylwrap.sh \
+ m4/missing-dev-prog.sh
+
+SUBDIRS = drmaa_utils test
+
Index: trunk/drmaa_utils/autogen.sh
===================================================================
--- trunk/drmaa_utils/autogen.sh	(revision 1)
+++ trunk/drmaa_utils/autogen.sh	(revision 1)
@@ -0,0 +1,48 @@
+#!/bin/sh
+# $Id: autogen.sh 1656 2008-11-18 17:11:58Z lukasz $
+
+run() {
+	echo "running $@ ($PWD)"
+	eval "$@"
+}
+
+check()
+{
+	printf "checking for $1... "
+	if ($1 --version < /dev/null > /dev/null 2>&1); then
+		echo "yes"
+	else
+		echo "no"
+		exit 1
+	fi
+}
+
+ACLOCAL=${ACLOCAL:=aclocal}
+AUTOHEADER=${AUTOHEADER:=autoheader}
+AUTOCONF=${AUTOCONF:=autoconf}
+LIBTOOLIZE=${LIBTOOLIZE:=libtoolize}
+AUTOMAKE=${AUTOMAKE:=automake}
+
+check $ACLOCAL
+check $AUTOHEADER
+check $AUTOCONF
+check $LIBTOOLIZE
+check $AUTOMAKE
+
+mkdir -p scripts
+
+run ${ACLOCAL} -I m4 | grep -v ^/usr/share/aclocal || exit 1
+run ${LIBTOOLIZE} --automake --copy --force || exit 1
+run ${AUTOHEADER} --warnings=all || exit 1
+run ${AUTOMAKE} --foreign --add-missing --copy --warnings=all || exit 1
+run ${AUTOCONF} --warnings=all -Wno-obsolete || exit 1
+
+if [ -n "$*" ]; then
+	args="$*"
+elif [ -f config.log ]; then
+	args=`grep '\$ *\./configure ' config.log \
+			 | sed 's:^ *\$ *\./configure ::;s:--no-create::;s:--no-recursion::' \
+			 2>/dev/null`
+fi
+
+run ./configure ${args}
Index: trunk/drmaa_utils/.boring
===================================================================
--- trunk/drmaa_utils/.boring	(revision 1)
+++ trunk/drmaa_utils/.boring	(revision 1)
@@ -0,0 +1,49 @@
+# Project specific:
+^drmaa_utils/conf_tab.c$
+^drmaa_utils/conf_tab.h$
+^drmaa_utils/datetime_tab.c$
+^drmaa_utils/datetime_tab.h$
+^drmaa_utils/drmaa_attrib.c$
+^test/test_exception$
+
+# Autotools:
+^configure$
+(^|/)config\.(log|status)$
+^scripts$
+^aclocal\.m4$
+(^|/)autom4te\.cache($|/)
+^config\.h(\.in)?$
+^stamp-h1$
+(^|/)Makefile(\.in)?$
+(^|/)\.(deps|libs)$
+^libtool$
+
+# Boring file regexps:
+^project/project.py$
+^test-results($|/)
+\.(o|obj|a|exe|so|lo|loT|la)$
+\.py[co]$
+\.class$
+(^|/)RCS($|/)
+,v$
+(^|/)CVS($|/)
+\.cvsignore$
+^\.#
+(^|/)\.svn($|/)
+(^|/)\.hg($|/)
+(^|/)\.git($|/)
+(^|/)\.bzr($|/)
+(^|/)BitKeeper($|/)
+(^|/)_darcs($|/)
+^\.darcs-temp-mail$
+-darcs-backup[[:digit:]]+$
+^\.darcs-temp-mail$
+^darcs-amend-record-[0-9]+$
+\.bak$
+\.BAK$
+\.orig$
+\.swp$
+(^|/|\.)core$
+(^|/)(tags|TAGS)$
+(^|/)Thumbs\.db$
+
Index: trunk/drmaa_utils/test/Makefile.am
===================================================================
--- trunk/drmaa_utils/test/Makefile.am	(revision 1)
+++ trunk/drmaa_utils/test/Makefile.am	(revision 1)
@@ -0,0 +1,26 @@
+# $Id: Makefile.am 1509 2008-10-12 14:21:23Z mmamonski $
+#
+# FedStage DRMAA utilities library
+# Copyright (C) 2006-2008  FedStage Systems
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+#
+
+
+LDADD = $(top_builddir)/drmaa_utils/libdrmaa_utils.la
+AM_CPPFLAGS = -DDEBUG
+
+TESTS = exception_test
+check_PROGRAMS = $(TESTS)
+
Index: trunk/drmaa_utils/test/run.py
===================================================================
--- trunk/drmaa_utils/test/run.py	(revision 1)
+++ trunk/drmaa_utils/test/run.py	(revision 1)
@@ -0,0 +1,53 @@
+
+import subprocess
+from os.path import join, dirname
+
+valid_outputs = [
+"""\
+try
+after try
+""",
+
+"""\
+try
+else
+finally
+""",
+
+"""\
+try
+except: Invalid argument value.
+finally
+""",
+
+"""\
+runner: before
+inner try
+inner finally
+except: Invalid argument value.
+finally
+runner: except: Invalid argument value.
+""",
+
+"""\
+runner: before
+except: Invalid argument value.
+finally
+runner: except: Unexpected or internal error.
+""",
+]
+
+
+def check_output(test_no):
+	executable = join(dirname(__file__), "test_exception")
+	p = subprocess.Popen(
+			args=[executable, str(test_no)],
+			stdout=subprocess.PIPE,
+			)
+	output = p.communicate()[0]
+	assert output == valid_outputs[test_no]
+
+def test_exception():
+	for i in range(5):
+		yield check_output, i
+
Index: trunk/drmaa_utils/test/exception_test.c
===================================================================
--- trunk/drmaa_utils/test/exception_test.c	(revision 1)
+++ trunk/drmaa_utils/test/exception_test.c	(revision 1)
@@ -0,0 +1,184 @@
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <assert.h>
+
+#include <drmaa_utils/common.h>
+
+
+void
+raise_ex( int err_code )
+{
+	fsd_exc_raise_code( err_code );
+	printf( "after raise\n" );
+	assert(0);
+}
+
+
+void
+runner( void (*function)(void) )
+{
+	int volatile in_except_default_block = 0;
+	TRY
+	 {
+		printf( "runner: before\n" );
+		function();
+		printf( "runner: after\n" );
+		assert(0);
+	 }
+	EXCEPT_DEFAULT
+	 {
+		printf( "runner: except: %s\n", fsd_exc_get()->_message );
+		in_except_default_block = 1;
+	 }
+	END_TRY
+	
+	assert(in_except_default_block);
+}
+
+
+void test_0(void)
+{
+	TRY
+	 { printf( "try\n" ); }
+	EXCEPT( FSD_ERRNO_INVALID_VALUE )
+	 { 
+	    printf( "except\n" ); 
+		assert(0);
+	 }
+	END_TRY
+	printf( "after try\n" );
+	printf( "test finished.\n" );
+}
+
+
+void test_1(void)
+{
+
+	int volatile in_else = 0;
+	int volatile in_finally = 0;
+	TRY
+	 { printf( "try\n" ); }
+	EXCEPT_DEFAULT
+	 { printf( "except\n" ); assert(0); }
+	ELSE
+	 { printf( "else\n" ); in_else = 1; }
+	FINALLY
+	 { printf( "finally\n" ); in_finally = 1; }
+	END_TRY
+			
+	assert(in_else);
+	assert(in_finally);
+	printf( "test finished.\n" );
+}
+
+
+void test_2(void)
+{
+	int volatile in_except = 0;
+	int volatile in_finally = 0;
+	TRY
+	 {
+		printf( "try\n" );
+		raise_ex( FSD_ERRNO_INVALID_VALUE );
+		assert(0);
+	 }
+	EXCEPT_DEFAULT
+	 {
+		printf( "except: %s\n", fsd_exc_get()->_message );
+		in_except = 1;
+	 }
+	FINALLY
+	 {
+		printf( "finally\n" );
+		in_finally = 1;
+	 }
+	END_TRY
+	
+	assert(in_except);
+	assert(in_finally);
+	printf("test finished\n");
+}
+
+
+void test_3(void)
+{
+	int volatile  blocks_counter = 0;
+	TRY
+	 {
+		TRY
+		 {
+			blocks_counter++;
+			printf( "inner try\n" );
+			raise_ex( FSD_ERRNO_INVALID_VALUE );
+			assert(0);
+		 }
+		FINALLY
+		 {
+			blocks_counter++;
+			printf( "inner finally\n" );
+		 }
+		END_TRY
+		printf( "after\n" );
+		assert(0);
+	 }
+	EXCEPT_DEFAULT
+	 {
+	    blocks_counter++;
+		printf( "except: %s\n", fsd_exc_get()->_message );
+		fsd_exc_reraise();
+	 }
+	ELSE
+	 { printf( "else\n" ); assert(0); }
+	FINALLY
+	 {
+		printf( "finally\n" );
+		blocks_counter++;
+		assert(blocks_counter == 4);
+	 }
+	END_TRY
+	
+	assert(0);
+}
+
+
+void test_4(void)
+{
+	TRY
+	 {
+		raise_ex( FSD_ERRNO_INVALID_VALUE );
+		assert(0);
+	 }
+	EXCEPT( FSD_ERRNO_INVALID_VALUE )
+	 { printf( "except: %s\n", fsd_exc_get()->_message ); }
+	EXCEPT_DEFAULT
+	 { printf( "except_default: %s\n", fsd_exc_get()->_message ); assert(0); }
+	FINALLY
+	 {
+		printf( "finally\n" );
+		raise_ex( FSD_ERRNO_INTERNAL_ERROR );
+	 }
+	END_TRY
+			
+	assert(0);
+}
+
+
+int
+main( int argc, char *argv[] )
+{
+	printf("Running Test 0\n");
+	test_0();  
+	printf("Running Test 1\n");
+	test_1();
+	printf("Running Test 2\n");
+	test_2();  
+	printf("Running Test 3\n");
+	runner( test_3 );
+	printf("Running Test 4\n");
+	runner( test_4 );
+	printf("All tests done.\n");
+
+	return 0;
+}
+
Index: trunk/drmaa_utils/m4/ax_gperf.m4
===================================================================
--- trunk/drmaa_utils/m4/ax_gperf.m4	(revision 1)
+++ trunk/drmaa_utils/m4/ax_gperf.m4	(revision 1)
@@ -0,0 +1,60 @@
+# $Id$
+#
+# SYNOPSIS
+#
+#   AX_GPERF([ACTION-IF-FOUND[, [ACTION-IF-NOT-FOUND]])
+#
+# DESCRIPTION
+#
+#   Test for Gperf perfect hash function generator binary.
+#   When not found GPERF is set with location of fallback
+#   script which prints error message and exits with non-zero
+#   error code.
+#
+#   This macro calls::
+#
+#     AC_SUBST(GPERF)
+#
+# LAST MODIFICATION
+#
+#   2007-12-14
+#
+# LICENSE
+#
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
+#   and placed under Public Domain
+#
+
+AC_DEFUN([AX_GPERF], [
+	AC_MSG_CHECKING([for gperf])
+	if { echo a; echo b; echo c; } | gperf >/dev/null 2>&1; then
+		ax_prog_gperf_ok=yes
+		GPERF=gperf
+	else
+		if echo $srcdir | grep -q "^/"; then
+			abs_srcdir="$srcdir"
+		else
+			abs_srcdir="`pwd`/$srcdir"
+		fi
+		GPERF="${abs_builddir}/scripts/gperf-fallback.sh"
+		cat >$GPERF <<EOF
+#!/bin/sh
+cat >&2 <<MESSAGE
+ * ERROR: gperf was not found at configuration time while some sources are
+ * build by it.  Either install gperf <http://www.gnu.org/software/gperf/>
+ * or download tarball with generated sources included (than you will
+ * not be able to modify .gperf files).
+MESSAGE
+exit 1
+EOF
+		chmod +x $GPERF
+		ax_prog_gperf_ok=no
+	fi
+	AC_SUBST(GPERF)
+	AC_MSG_RESULT([$ax_prog_gperf_ok])
+	if test x$ax_prog_gperf_ok = xyes; then
+		ifelse([$1], , :, [$1])
+	else
+		ifelse([$2], , :, [$2])
+	fi
+])
Index: trunk/drmaa_utils/m4/ax_gcc_warnings.m4
===================================================================
--- trunk/drmaa_utils/m4/ax_gcc_warnings.m4	(revision 1)
+++ trunk/drmaa_utils/m4/ax_gcc_warnings.m4	(revision 1)
@@ -0,0 +1,50 @@
+# $Id: ax_gcc_warnings.m4 1542 2008-10-21 12:00:09Z lukasz $
+#
+# SYNOPSIS
+#
+#   AX_GCC_FLAGS()
+#
+# DESCRIPTION
+#
+#   Check for LSF libraries and headers.
+#
+#   This macro calls::
+#
+#			AC_SUBST(GCC_W_NO_MISSING_FIELD_INITIALIZERS)
+#			AC_SUBST(GCC_W_NO_FORMAT_ZERO_LENGTH)
+#
+# LAST MODIFICATION
+#
+#   2008-10-13
+#
+# LICENSE
+#
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
+#   and placed under Public Domain.
+#
+AC_DEFUN([AX_GCC_WARNINGS], [
+if test x$GCC == xyes; then
+	AC_SUBST([GCC_W_NO_MISSING_FIELD_INITIALIZERS])
+	AC_SUBST([GCC_W_NO_FORMAT_ZERO_LENGTH])
+	CFLAGS_save="$CFLAGS"
+
+	AC_MSG_CHECKING([whether gcc accepts -Wno-missing-field-initializers])
+	CFLAGS="$CFLAGS_save -Wall -Wextra -Wno-missing-field-initializers"
+	ax_gcc_warnings_src="int main(){ return 0; }"
+	AC_COMPILE_IFELSE([$ax_gcc_warnings_src],
+		[GCC_W_NO_MISSING_FIELD_INITIALIZERS="-Wno-missing-field-initializers"
+		AC_MSG_RESULT([yes])],
+		[GCC_W_NO_MISSING_FIELD_INITIALIZERS="-Wno-extra"
+		AC_MSG_RESULT([no])])
+
+	AC_MSG_CHECKING([whether gcc accepts -Wno-format-zero-length])
+	CFLAGS="$CFLAGS_save -Wno-format-zero-length"
+	AC_COMPILE_IFELSE([$ax_gcc_warnings_src],
+		[GCC_W_NO_FORMAT_ZERO_LENGTH="-Wno-format-zero-length"
+		AC_MSG_RESULT([yes])],
+		[GCC_W_NO_FORMAT_ZERO_LENGTH="-Wno-format"
+		AC_MSG_RESULT([no])])
+
+	CFLAGS="$CFLAGS_save"
+fi
+])
Index: trunk/drmaa_utils/m4/ac_c_bigendian_cross.m4
===================================================================
--- trunk/drmaa_utils/m4/ac_c_bigendian_cross.m4	(revision 1)
+++ trunk/drmaa_utils/m4/ac_c_bigendian_cross.m4	(revision 1)
@@ -0,0 +1,86 @@
+dnl @synopsis AC_C_BIGENDIAN_CROSS
+dnl
+dnl Check endianess even when crosscompiling (partially based on the
+dnl original AC_C_BIGENDIAN).
+dnl
+dnl The implementation will create a binary, but instead of running the
+dnl binary it will be grep'ed for some symbols that differ for
+dnl different endianess of the binary.
+dnl
+dnl NOTE: The upcoming autoconf 2.53 does include the idea of this
+dnl macro, what makes it superfluous by then.
+dnl
+dnl @category CrossCompilation
+dnl @author Guido Draheim <guidod@gmx.de>
+dnl @version 2002-03-18
+dnl @license GPLWithACException
+
+AC_DEFUN([AC_C_BIGENDIAN_CROSS],
+[AC_CACHE_CHECK(whether byte ordering is bigendian, ac_cv_c_bigendian,
+[ac_cv_c_bigendian=unknown
+# See if sys/param.h defines the BYTE_ORDER macro.
+AC_TRY_COMPILE([#include <sys/types.h>
+#include <sys/param.h>], [
+#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
+ bogus endian macros
+#endif], [# It does; now see whether it defined to BIG_ENDIAN or not.
+AC_TRY_COMPILE([#include <sys/types.h>
+#include <sys/param.h>], [
+#if BYTE_ORDER != BIG_ENDIAN
+ not big endian
+#endif], ac_cv_c_bigendian=yes, ac_cv_c_bigendian=no)])
+if test $ac_cv_c_bigendian = unknown; then
+AC_TRY_RUN([main () {
+  /* Are we little or big endian?  From Harbison&Steele.  */
+  union
+  {
+    long l;
+    char c[sizeof (long)];
+  } u;
+  u.l = 1;
+  exit (u.c[sizeof (long) - 1] == 1);
+}], ac_cv_c_bigendian=no, ac_cv_c_bigendian=yes,
+[ echo $ac_n "cross-compiling... " 2>&AC_FD_MSG ])
+fi])
+if test $ac_cv_c_bigendian = unknown; then
+AC_MSG_CHECKING(to probe for byte ordering)
+[
+cat >conftest.c <<EOF
+short ascii_mm[] = { 0x4249, 0x4765, 0x6E44, 0x6961, 0x6E53, 0x7953, 0 };
+short ascii_ii[] = { 0x694C, 0x5454, 0x656C, 0x6E45, 0x6944, 0x6E61, 0 };
+void _ascii() { char* s = (char*) ascii_mm; s = (char*) ascii_ii; }
+short ebcdic_ii[] = { 0x89D3, 0xE3E3, 0x8593, 0x95C5, 0x89C4, 0x9581, 0 };
+short ebcdic_mm[] = { 0xC2C9, 0xC785, 0x95C4, 0x8981, 0x95E2, 0xA8E2, 0 };
+void _ebcdic() { char* s = (char*) ebcdic_mm; s = (char*) ebcdic_ii; }
+int main() { _ascii (); _ebcdic (); return 0; }
+EOF
+] if test -f conftest.c ; then
+     if ${CC-cc} -c conftest.c -o conftest.o && test -f conftest.o ; then
+        if test `grep -l BIGenDianSyS conftest.o` ; then
+           echo $ac_n ' big endian probe OK, ' 1>&AC_FD_MSG
+	   ac_cv_c_bigendian=yes
+        fi
+        if test `grep -l LiTTleEnDian conftest.o` ; then
+           echo $ac_n ' little endian probe OK, ' 1>&AC_FD_MSG
+	   if test $ac_cv_c_bigendian = yes ; then
+	    ac_cv_c_bigendian=unknown;
+           else
+            ac_cv_c_bigendian=no
+           fi
+        fi
+	echo $ac_n 'guessing bigendian ...  ' >&AC_FD_MSG
+     fi
+  fi
+AC_MSG_RESULT($ac_cv_c_bigendian)
+fi
+if test $ac_cv_c_bigendian = yes; then
+  AC_DEFINE(WORDS_BIGENDIAN, 1, [whether byteorder is bigendian])
+  BYTEORDER=4321
+else
+  BYTEORDER=1234
+fi
+AC_DEFINE_UNQUOTED(BYTEORDER, $BYTEORDER, [1234 = LIL_ENDIAN, 4321 = BIGENDIAN])
+if test $ac_cv_c_bigendian = unknown; then
+  AC_MSG_ERROR(unknown endianess - sorry, please pre-set ac_cv_c_bigendian)
+fi
+])
Index: trunk/drmaa_utils/m4/ax_docutils.m4
===================================================================
--- trunk/drmaa_utils/m4/ax_docutils.m4	(revision 1)
+++ trunk/drmaa_utils/m4/ax_docutils.m4	(revision 1)
@@ -0,0 +1,33 @@
+# $Id$
+#
+# SYNOPSIS
+#
+#   AX_DOCUTILS([ACTION-IF-FOUND[, ACTION-IF-NOT-FOUND]])
+#
+# DESCRIPTION
+#
+#   Test for the Docutils -- Python driven reStructuredText processor.
+#   This macro calls (through AC_CHECK_PROGS)::
+#
+#     AC_SUBST(RST2HTML)
+#     AC_SUBST(RST2LATEX)
+#
+# LAST MODIFICATION
+#
+#   2007-12-14
+#
+# LICENSE
+#
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
+#   and placed under Public Domain
+#
+
+AC_DEFUN([AX_DOCUTILS], [
+	AC_CHECK_PROGS([RST2HTML], [rst2html rst2html.py])
+	AC_CHECK_PROGS([RST2LATEX], [rst2latex rst2latex.py])
+	if test x$RST2HTML != x -a x$RST2LATEX != x; then
+		ifelse([$1], , :, [$1])
+	else
+		ifelse([$2], , :, [$2])
+	fi
+])
Index: trunk/drmaa_utils/m4/acx_pthread.m4
===================================================================
--- trunk/drmaa_utils/m4/acx_pthread.m4	(revision 1)
+++ trunk/drmaa_utils/m4/acx_pthread.m4	(revision 1)
@@ -0,0 +1,245 @@
+dnl $Id$
+
+dnl
+dnl Check for libs/cppflags needed for POSIX Threads
+dnl
+
+dnl @synopsis ACX_PTHREAD([ACTION-IF-FOUND[, ACTION-IF-NOT-FOUND]])
+dnl
+dnl Modified from the original version:
+dnl * Removed pthread-specific CC support
+dnl * Added FreeBSD specific -pthread/-lpthread flags
+dnl Notes:
+dnl * -D_THREAD_SAFE may not be necessary on FreeBSD
+dnl   and elsewhere.
+dnl - landonf March 25th, 2005
+dnl
+dnl This macro figures out how to build C programs using POSIX threads.
+dnl It sets the PTHREAD_LIBS output variable to the threads library and
+dnl linker flags, and the PTHREAD_CFLAGS output variable to any special
+dnl C compiler flags that are needed. (The user can also force certain
+dnl compiler flags/libs to be tested by setting these environment
+dnl variables.)
+dnl
+dnl NOTE: You are assumed to not only compile your program with these
+dnl flags, but also link it with them as well. e.g. you should link
+dnl with $CC $CFLAGS $PTHREAD_CFLAGS $LDFLAGS ... $PTHREAD_LIBS
+dnl $LIBS
+dnl
+dnl If you are only building threads programs, you may wish to use
+dnl these variables in your default LIBS, and CFLAGS:
+dnl
+dnl        LIBS="$PTHREAD_LIBS $LIBS"
+dnl        CFLAGS="$CFLAGS $PTHREAD_CFLAGS"
+dnl
+dnl In addition, if the PTHREAD_CREATE_JOINABLE thread-attribute
+dnl constant has a nonstandard name, defines PTHREAD_CREATE_JOINABLE to
+dnl that name (e.g. PTHREAD_CREATE_UNDETACHED on AIX).
+dnl
+dnl ACTION-IF-FOUND is a list of shell commands to run if a threads
+dnl library is found, and ACTION-IF-NOT-FOUND is a list of commands to
+dnl run it if it is not found. If ACTION-IF-FOUND is not specified, the
+dnl default action will define HAVE_PTHREAD.
+dnl
+dnl Please let the authors know if this macro fails on any platform, or
+dnl if you have any other suggestions or comments. This macro was based
+dnl on work by SGJ on autoconf scripts for FFTW (www.fftw.org) (with
+dnl help from M. Frigo), as well as ac_pthread and hb_pthread macros
+dnl posted by Alejandro Forero Cuervo to the autoconf macro repository.
+dnl We are also grateful for the helpful feedback of numerous users.
+dnl
+dnl @category InstalledPackages
+dnl @author Steven G. Johnson <stevenj@alum.mit.edu>
+dnl @version 2005-01-14
+dnl @license GPLWithACException
+
+AC_DEFUN([ACX_PTHREAD], [
+AC_REQUIRE([AC_CANONICAL_HOST])
+AC_LANG_SAVE
+AC_LANG_C
+acx_pthread_ok=no
+
+# We used to check for pthread.h first, but this fails if pthread.h
+# requires special compiler flags (e.g. on True64 or Sequent).
+# It gets checked for in the link test anyway.
+
+# First of all, check if the user has set any of the PTHREAD_LIBS,
+# etcetera environment variables, and if threads linking works using
+# them:
+if test x"$PTHREAD_LIBS$PTHREAD_CFLAGS" != x; then
+        save_CFLAGS="$CFLAGS"
+        CFLAGS="$CFLAGS $PTHREAD_CFLAGS"
+        save_LIBS="$LIBS"
+        LIBS="$PTHREAD_LIBS $LIBS"
+        AC_MSG_CHECKING([for pthread_join in LIBS=$PTHREAD_LIBS with CFLAGS=$PTHREAD_CFLAGS])
+        AC_TRY_LINK_FUNC(pthread_join, acx_pthread_ok=yes)
+        AC_MSG_RESULT($acx_pthread_ok)
+        if test x"$acx_pthread_ok" = xno; then
+                PTHREAD_LIBS=""
+                PTHREAD_CFLAGS=""
+        fi
+        LIBS="$save_LIBS"
+        CFLAGS="$save_CFLAGS"
+fi
+
+# We must check for the threads library under a number of different
+# names; the ordering is very important because some systems
+# (e.g. DEC) have both -lpthread and -lpthreads, where one of the
+# libraries is broken (non-POSIX).
+
+# Create a list of thread flags to try.  Items starting with a "-" are
+# C compiler flags, and other items are library names, except for "none"
+# which indicates that we try without any flags at all, and "pthread-config"
+# which is a program returning the flags for the Pth emulation library.
+
+acx_pthread_flags="pthreads none -Kthread -kthread lthread -pthread -pthreads -mthreads pthread --thread-safe -mt pthread-config"
+
+# The ordering *is* (sometimes) important.  Some notes on the
+# individual items follow:
+
+# pthreads: AIX (must check this before -lpthread)
+# none: in case threads are in libc; should be tried before -Kthread and
+#       other compiler flags to prevent continual compiler warnings
+# -Kthread: Sequent (threads in libc, but -Kthread needed for pthread.h)
+# -kthread: FreeBSD kernel threads (preferred to -pthread since SMP-able)
+# lthread: LinuxThreads port on FreeBSD (also preferred to -pthread)
+# -pthread: Linux/gcc (kernel threads), BSD/gcc (userland threads)
+# -pthreads: Solaris/gcc
+# -mthreads: Mingw32/gcc, Lynx/gcc
+# -mt: Sun Workshop C (may only link SunOS threads [-lthread], but it
+#      doesn't hurt to check since this sometimes defines pthreads too;
+#      also defines -D_REENTRANT)
+# pthread: Linux, etcetera
+# --thread-safe: KAI C++
+# pthread-config: use pthread-config program (for GNU Pth library)
+
+case "${host_cpu}-${host_os}" in
+        *solaris*)
+
+        # On Solaris (at least, for some versions), libc contains stubbed
+        # (non-functional) versions of the pthreads routines, so link-based
+        # tests will erroneously succeed.  (We need to link with -pthread or
+        # -lpthread.)  (The stubs are missing pthread_cleanup_push, or rather
+        # a function called by this macro, so we could check for that, but
+        # who knows whether they'll stub that too in a future libc.)  So,
+        # we'll just look for -pthreads and -lpthread first:
+
+        acx_pthread_flags="-pthread -pthreads pthread -mt $acx_pthread_flags"
+        ;;
+
+	*freebsd*)
+	# freebsd 4 uses -pthread, freebsd 5 uses -lpthread
+	acx_pthread_flags="pthread -pthread"
+	;;
+esac
+
+if test x"$acx_pthread_ok" = xno; then
+for flag in $acx_pthread_flags; do
+
+        case $flag in
+                none)
+                AC_MSG_CHECKING([whether pthreads work without any flags])
+                ;;
+
+                -*)
+                AC_MSG_CHECKING([whether pthreads work with $flag])
+                PTHREAD_CFLAGS="$flag"
+                PTHREAD_LIBS="$flag"
+                ;;
+
+		pthread-config)
+		AC_CHECK_PROG(acx_pthread_config, pthread-config, yes, no)
+		if test x"$acx_pthread_config" = xno; then continue; fi
+		PTHREAD_CFLAGS="`pthread-config --cflags`"
+		PTHREAD_LIBS="`pthread-config --ldflags` `pthread-config --libs`"
+		;;
+
+                *)
+                AC_MSG_CHECKING([for the pthreads library -l$flag])
+                PTHREAD_LIBS="-l$flag"
+                ;;
+        esac
+
+        save_LIBS="$LIBS"
+        save_CFLAGS="$CFLAGS"
+        LIBS="$PTHREAD_LIBS $LIBS"
+        CFLAGS="$CFLAGS $PTHREAD_CFLAGS"
+
+        # Check for various functions.  We must include pthread.h,
+        # since some functions may be macros.  (On the Sequent, we
+        # need a special flag -Kthread to make this header compile.)
+        # We check for pthread_join because it is in -lpthread on IRIX
+        # while pthread_create is in libc.  We check for pthread_attr_init
+        # due to DEC craziness with -lpthreads.  We check for
+        # pthread_cleanup_push because it is one of the few pthread
+        # functions on Solaris that doesn't have a non-functional libc stub.
+        # We try pthread_create on general principles.
+        AC_TRY_LINK([#include <pthread.h>],
+                    [pthread_t th; pthread_join(th, 0);
+                     pthread_attr_init(0); pthread_cleanup_push(0, 0);
+                     pthread_create(0,0,0,0); pthread_cleanup_pop(0); ],
+                    [acx_pthread_ok=yes])
+
+        LIBS="$save_LIBS"
+        CFLAGS="$save_CFLAGS"
+
+        AC_MSG_RESULT($acx_pthread_ok)
+        if test "x$acx_pthread_ok" = xyes; then
+                break;
+        fi
+
+        PTHREAD_LIBS=""
+        PTHREAD_CFLAGS=""
+done
+fi
+
+# Various other checks:
+if test "x$acx_pthread_ok" = xyes; then
+        save_LIBS="$LIBS"
+        LIBS="$PTHREAD_LIBS $LIBS"
+        save_CFLAGS="$CFLAGS"
+        CFLAGS="$CFLAGS $PTHREAD_CFLAGS"
+
+        # Detect AIX lossage: JOINABLE attribute is called UNDETACHED.
+	AC_MSG_CHECKING([for joinable pthread attribute])
+	attr_name=unknown
+	for attr in PTHREAD_CREATE_JOINABLE PTHREAD_CREATE_UNDETACHED; do
+	    AC_TRY_LINK([#include <pthread.h>], [int attr=$attr;],
+                        [attr_name=$attr; break])
+	done
+        AC_MSG_RESULT($attr_name)
+        if test "$attr_name" != PTHREAD_CREATE_JOINABLE; then
+            AC_DEFINE_UNQUOTED(PTHREAD_CREATE_JOINABLE, $attr_name,
+                               [Define to necessary symbol if this constant
+                                uses a non-standard name on your system.])
+        fi
+
+        AC_MSG_CHECKING([if more special flags are required for pthreads])
+        flag=no
+        case "${host_cpu}-${host_os}" in
+            *-aix* | *-freebsd* | *-darwin*) flag="-D_THREAD_SAFE";;
+            *solaris* | *-osf* | *-hpux*) flag="-D_REENTRANT";;
+        esac
+        AC_MSG_RESULT(${flag})
+        if test "x$flag" != xno; then
+            PTHREAD_CFLAGS="$flag $PTHREAD_CFLAGS"
+        fi
+
+        LIBS="$save_LIBS"
+        CFLAGS="$save_CFLAGS"
+
+fi
+
+AC_SUBST(PTHREAD_LIBS)
+AC_SUBST(PTHREAD_CFLAGS)
+
+# Finally, execute ACTION-IF-FOUND/ACTION-IF-NOT-FOUND:
+if test x"$acx_pthread_ok" = xyes; then
+        ifelse([$1],,AC_DEFINE(HAVE_PTHREAD,1,[Define if you have POSIX threads libraries and header files.]),[$1])
+        :
+else
+        acx_pthread_ok=no
+        $2
+fi
+AC_LANG_RESTORE
+])dnl ACX_PTHREAD
Index: trunk/drmaa_utils/m4/bison_ylwrap.sh
===================================================================
--- trunk/drmaa_utils/m4/bison_ylwrap.sh	(revision 1)
+++ trunk/drmaa_utils/m4/bison_ylwrap.sh	(revision 1)
@@ -0,0 +1,37 @@
+#!/bin/sh
+# ylwrap script specially crafted for Bison
+
+input="$1"; shift
+
+while true; do
+	case "$1" in
+		"")  exit 1;;
+		--)  shift; break;;
+		*)   shift;;
+	esac
+done
+
+prog="$1"; shift; args=$@
+if [ ${prog} != "bison" ]; then
+	cat >&2 <<EOF
+ * ERROR: Bison was not found at configuration time while some sources are
+ * build by it.  Either install Bison <http://www.gnu.org/software/bison/>
+ * or download tarball with generated sources included (than you will
+ * not be able to modify .y files).
+EOF
+	exit 1
+fi
+
+real_args=""
+for i in $args; do
+	case "$i" in
+		-y)  ;;
+		--yacc)  ;;
+		*)  real_args="$real_args $i" ;;
+	esac
+done
+
+echo "${prog} --output=`basename ${input} .y`.c ${real_args[@]} ${input}"
+${prog} --output=`basename ${input} .y`.c ${real_args[@]} ${input}
+
+
Index: trunk/drmaa_utils/m4/ax_func_gettid.m4
===================================================================
--- trunk/drmaa_utils/m4/ax_func_gettid.m4	(revision 1)
+++ trunk/drmaa_utils/m4/ax_func_gettid.m4	(revision 1)
@@ -0,0 +1,50 @@
+# $Id$
+#
+# SYNOPSIS
+#
+#   AX_FUNC_GETTID([ACTION-IF-FOUND[, ACTION-IF-NOT-FOUND]])
+#
+# DESCRIPTION
+#
+#   Check for gettid system call.  When found this macro
+#   defines HAVE_GETTID.  It may be used after following
+#   definition (it is not defined in Linux headers)::
+#
+#     #include <sys/types.h>
+#     #include <sys/syscall.h>
+#     pid_t gettid(void) {  return (pid_t)syscall( __NR_gettid );  }
+#
+# LAST MODIFICATION
+#
+#   2008-06-13
+#
+# LICENSE
+#
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
+#   and placed under Public Domain
+#
+
+AC_DEFUN([AX_FUNC_GETTID],[
+AC_MSG_CHECKING([for gettid])
+AC_REQUIRE([AC_PROG_CC])
+AH_TEMPLATE([HAVE_GETTID], [Define to 1 if you have the gettid() syscall.])
+
+AC_LANG_PUSH([C])
+AC_COMPILE_IFELSE(
+	AC_LANG_PROGRAM([[
+@%:@include <sys/types.h>
+@%:@include <sys/syscall.h>
+@%:@include <unistd.h>
+pid_t gettid(void) { return (pid_t)syscall(__NR_gettid); }]],
+	[[pid_t tid = gettid(); return 0;]]),
+[ax_func_gettid_ok=yes], [ax_func_gettid_ok=no])
+AC_LANG_POP([C])
+
+AC_MSG_RESULT([$ax_func_gettid_ok])
+if test x$ax_func_gettid_ok = xyes; then
+	AC_DEFINE([HAVE_GETTID], [1])
+	ifelse([$1], , :, [$1])
+else
+	ifelse([$2], , :, [$2])
+fi
+])
Index: trunk/drmaa_utils/m4/ax_func_va_copy.m4
===================================================================
--- trunk/drmaa_utils/m4/ax_func_va_copy.m4	(revision 1)
+++ trunk/drmaa_utils/m4/ax_func_va_copy.m4	(revision 1)
@@ -0,0 +1,66 @@
+# $Id$
+#
+# SYNOPSIS
+#
+#   AX_FUNC_VA_COPY([ACTION-IF-FOUND[, [ACTION-IF-NOT-FOUND]])
+#
+# DESCRIPTION
+#
+#   Test for va_copy function/macro.
+#   When found it defines ``HAVE_VA_COPY`` and/or ``HAVE___VA_COPY``
+#   when ``va_copy`` and/or ``__va_copy`` is found respectively.
+#
+# LAST MODIFICATION
+#
+#   2008-06-13
+#
+# LICENSE
+#
+#   Written by Åukasz CieÅnik <lukasz.ciesnik@fedstage.com>
+#   and placed under Public Domain.
+#
+
+AC_DEFUN([AX_FUNC_VA_COPY], [
+
+ax_func_va_copy_ok=no
+
+AH_TEMPLATE([HAVE_VA_COPY],
+		[Define to 1 if you have the va_copy function.])
+AC_MSG_CHECKING([for va_copy])
+AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <stdarg.h>]],
+			[[va_list a, b; va_copy(a, b);]])],[
+	ax_func_va_copy_ok=yes
+  AC_MSG_RESULT([yes])
+  AC_DEFINE([HAVE_VA_COPY], [1])
+  ],[
+      AC_MSG_RESULT([no])
+  ],[
+      AC_MSG_RESULT([no])
+])
+
+AH_TEMPLATE([HAVE___VA_COPY],
+		[Define to 1 if you have the __va_copy function.])
+AC_MSG_CHECKING([for __va_copy])
+AC_LINK_IFELSE([AC_LANG_PROGRAM([[#include <stdarg.h>]],
+			[[va_list a, b; __va_copy(a, b);]])],[
+	ax_func_va_copy_ok=yes
+  AC_MSG_RESULT([yes])
+  AC_DEFINE([HAVE___VA_COPY], [1])
+	AH_BOTTOM([
+#ifndef HAVE_VA_COPY
+#	define va_copy(a,b) __va_copy(a,b)
+#	define HAVE_VA_COPY 1
+#endif
+])
+  ], [
+  AC_MSG_RESULT([no])
+  ], [
+  AC_MSG_RESULT([no])
+])
+
+if test x$ax_func_va_copy_ok = xyes; then
+	ifelse([$1], , :, [$1])
+else
+	ifelse([$2], , :, [$2])
+fi
+])
